From 0dfcb0df0dc04e672e328582734a55500d3dadbd Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Sat, 16 Dec 2023 11:33:00 +0200
Subject: [PATCH 25/25] Remove double spaces from Temple description

See RM #66

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/civ1/buildings.ruleset          | 6 +++---
 data/civ2/buildings.ruleset          | 6 +++---
 data/classic/buildings.ruleset       | 6 +++---
 data/goldkeep/buildings.ruleset      | 6 +++---
 data/multiplayer/buildings.ruleset   | 6 +++---
 data/webperimental/buildings.ruleset | 6 +++---
 6 files changed, 18 insertions(+), 18 deletions(-)

diff --git a/data/civ1/buildings.ruleset b/data/civ1/buildings.ruleset
index 7e4c7240d1..50baf53224 100644
--- a/data/civ1/buildings.ruleset
+++ b/data/civ1/buildings.ruleset
@@ -794,9 +794,9 @@ sound		= "b_temple"
 sound_alt	= "b_generic"
 sound_alt2      = "-"
 helptext	= _("\
-Makes one unhappy citizen content.  The Mysticism advance doubles\
- this effect, as does the Oracle wonder.  With both Mysticism and the Oracle,\
- 4 citizens are made content.  Does not affect citizens made unhappy by military\
+Makes one unhappy citizen content. The Mysticism advance doubles\
+ this effect, as does the Oracle wonder. With both Mysticism and the Oracle,\
+ 4 citizens are made content. Does not affect citizens made unhappy by military\
  activity.\
 "), _("\
 A Temple in a city near mountains additionally prevents population loss\
diff --git a/data/civ2/buildings.ruleset b/data/civ2/buildings.ruleset
index 4105b36a99..5ea54b5e1c 100644
--- a/data/civ2/buildings.ruleset
+++ b/data/civ2/buildings.ruleset
@@ -1145,9 +1145,9 @@ sound		= "b_temple"
 sound_alt	= "b_generic"
 sound_alt2      = "-"
 helptext	= _("\
-Makes one unhappy citizen content.  The Mysticism advance doubles\
- this effect, as does Oracle wonder.  With both Mysticism and the Oracle,\
- 4 citizens are made content.  Does not affect citizens made unhappy by military\
+Makes one unhappy citizen content. The Mysticism advance doubles\
+ this effect, as does Oracle wonder. With both Mysticism and the Oracle,\
+ 4 citizens are made content. Does not affect citizens made unhappy by military\
  activity.\
 ")
 
diff --git a/data/classic/buildings.ruleset b/data/classic/buildings.ruleset
index 471ebdd07f..69f4fbf65f 100644
--- a/data/classic/buildings.ruleset
+++ b/data/classic/buildings.ruleset
@@ -1190,9 +1190,9 @@ sound		= "b_temple"
 sound_alt	= "b_generic"
 sound_alt2      = "-"
 helptext	= _("\
-Makes one unhappy citizen content.  The Mysticism advance doubles\
- this effect.  With both Mysticism and the Oracle, 4 citizens are\
- made content.  Does not affect citizens made unhappy by military\
+Makes one unhappy citizen content. The Mysticism advance doubles\
+ this effect. With both Mysticism and the Oracle, 4 citizens are\
+ made content. Does not affect citizens made unhappy by military\
  activity.\
 ")
 
diff --git a/data/goldkeep/buildings.ruleset b/data/goldkeep/buildings.ruleset
index 625478a220..a296157edf 100644
--- a/data/goldkeep/buildings.ruleset
+++ b/data/goldkeep/buildings.ruleset
@@ -1253,9 +1253,9 @@ sound		= "b_temple"
 sound_alt	= "b_generic"
 sound_alt2      = "-"
 helptext	= _("\
-Makes one unhappy citizen content.  The Mysticism advance doubles\
- this effect.  With both Mysticism and the Oracle, 4 citizens are\
- made content.  Does not affect citizens made unhappy by military\
+Makes one unhappy citizen content. The Mysticism advance doubles\
+ this effect. With both Mysticism and the Oracle, 4 citizens are\
+ made content. Does not affect citizens made unhappy by military\
  activity.\
 "), _("\
 The work of the priests also reduces the effect of plague in the city.\
diff --git a/data/multiplayer/buildings.ruleset b/data/multiplayer/buildings.ruleset
index 05cfdfa715..1f77288609 100644
--- a/data/multiplayer/buildings.ruleset
+++ b/data/multiplayer/buildings.ruleset
@@ -1165,9 +1165,9 @@ sound		= "b_temple"
 sound_alt	= "b_generic"
 sound_alt2      = "-"
 helptext	= _("\
-Makes one unhappy citizen content.  The Mysticism advance doubles\
- this effect.  With both Mysticism and the Oracle, 4 citizens are\
- made content.  Does not affect citizens made unhappy by military\
+Makes one unhappy citizen content. The Mysticism advance doubles\
+ this effect. With both Mysticism and the Oracle, 4 citizens are\
+ made content. Does not affect citizens made unhappy by military\
  activity.\
 ")
 
diff --git a/data/webperimental/buildings.ruleset b/data/webperimental/buildings.ruleset
index 10e505955a..179c03dbc6 100644
--- a/data/webperimental/buildings.ruleset
+++ b/data/webperimental/buildings.ruleset
@@ -1197,9 +1197,9 @@ sound		= "b_temple"
 sound_alt	= "b_generic"
 sound_alt2      = "-"
 helptext	= _("\
-Makes one unhappy citizen content.  The Mysticism advance doubles\
- this effect.  With both Mysticism and the Oracle, 4 citizens are\
- made content.  Does not affect citizens made unhappy by military\
+Makes one unhappy citizen content. The Mysticism advance doubles\
+ this effect. With both Mysticism and the Oracle, 4 citizens are\
+ made content. Does not affect citizens made unhappy by military\
  activity.\
 ")
 
-- 
2.43.0