From b81e72d93de86a76c6644f68b4be7cff40cf5b81 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Mon, 1 Jan 2024 23:04:55 +0200
Subject: [PATCH 29/29] units.rulesets: Update Flagless unit type flag
 documentation

See RM #106

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/alien/units.ruleset         | 5 ++---
 data/civ1/units.ruleset          | 5 ++---
 data/civ2/units.ruleset          | 5 ++---
 data/civ2civ3/units.ruleset      | 5 ++---
 data/classic/units.ruleset       | 5 ++---
 data/goldkeep/units.ruleset      | 5 ++---
 data/granularity/units.ruleset   | 5 ++---
 data/multiplayer/units.ruleset   | 5 ++---
 data/ruledit/comments-3.3.txt    | 5 ++---
 data/sandbox/units.ruleset       | 5 ++---
 data/stub/units.ruleset          | 5 ++---
 data/webperimental/units.ruleset | 5 ++---
 12 files changed, 24 insertions(+), 36 deletions(-)

diff --git a/data/alien/units.ruleset b/data/alien/units.ruleset
index d81665ddbd..ae0bac6cc3 100644
--- a/data/alien/units.ruleset
+++ b/data/alien/units.ruleset
@@ -386,9 +386,8 @@ flags         = "Missile", "DoesntOccupyTile"
 ; "RandomMovement" = Unit makes random movements in the beginning of the turn,
 ;                 player has no control over its movement
 ; "Flagless"      = Unit national flag is not shown on client, except for
-;                 the owner.
-;                 Note that currently the information is available for
-;                 the client anyway, so this is not a rule like a feature yet.
+;                 the owner. Unit can attack, and it can be attacked,
+;                 regardless of diplomatic pacts between actual unit owners.
 ; "ProvidesRansom" = Enemies can collect ransom from the unit. This only happens
 ;                 if all the units on tile have this flag - any other kind of
 ;                 unit protects them.
diff --git a/data/civ1/units.ruleset b/data/civ1/units.ruleset
index 71ace8dcdf..9b6a8b406b 100644
--- a/data/civ1/units.ruleset
+++ b/data/civ1/units.ruleset
@@ -361,9 +361,8 @@ flags         = "Missile", "Unreachable", "HutNothing"
 ; "RandomMovement" = Unit makes random movements in the beginning of the turn,
 ;                 player has no control over its movement
 ; "Flagless"      = Unit national flag is not shown on client, except for
-;                 the owner.
-;                 Note that currently the information is available for
-;                 the client anyway, so this is not a rule like a feature yet.
+;                 the owner. Unit can attack, and it can be attacked,
+;                 regardless of diplomatic pacts between actual unit owners.
 ; "ProvidesRansom" = Enemies can collect ransom from the unit. This only happens
 ;                 if all the units on tile have this flag - any other kind of
 ;                 unit protects them.
diff --git a/data/civ2/units.ruleset b/data/civ2/units.ruleset
index 28b9a2fcf0..8fa0638a70 100644
--- a/data/civ2/units.ruleset
+++ b/data/civ2/units.ruleset
@@ -379,9 +379,8 @@ flags         = "Unreachable", "DoesntOccupyTile", "HutFrighten"
 ; "RandomMovement" = Unit makes random movements in the beginning of the turn,
 ;                 player has no control over its movement
 ; "Flagless"      = Unit national flag is not shown on client, except for
-;                 the owner.
-;                 Note that currently the information is available for
-;                 the client anyway, so this is not a rule like a feature yet.
+;                 the owner. Unit can attack, and it can be attacked,
+;                 regardless of diplomatic pacts between actual unit owners.
 ; "ProvidesRansom" = Enemies can collect ransom from the unit. This only happens
 ;                 if all the units on tile have this flag - any other kind of
 ;                 unit protects them.
diff --git a/data/civ2civ3/units.ruleset b/data/civ2civ3/units.ruleset
index 742baca24b..0a5d372fa9 100644
--- a/data/civ2civ3/units.ruleset
+++ b/data/civ2civ3/units.ruleset
@@ -423,9 +423,8 @@ flags         = "Unreachable", "DoesntOccupyTile", "CanPillage",
 ; "RandomMovement" = Unit makes random movements in the beginning of the turn,
 ;                 player has no control over its movement
 ; "Flagless"      = Unit national flag is not shown on client, except for
-;                 the owner.
-;                 Note that currently the information is available for
-;                 the client anyway, so this is not a rule like a feature yet.
+;                 the owner. Unit can attack, and it can be attacked,
+;                 regardless of diplomatic pacts between actual unit owners.
 ; "ProvidesRansom" = Enemies can collect ransom from the unit. This only happens
 ;                 if all the units on tile have this flag - any other kind of
 ;                 unit protects them.
diff --git a/data/classic/units.ruleset b/data/classic/units.ruleset
index 0fb8bbd2af..3996e73fbd 100644
--- a/data/classic/units.ruleset
+++ b/data/classic/units.ruleset
@@ -389,9 +389,8 @@ flags         = "Unreachable", "DoesntOccupyTile", "HutFrighten"
 ; "RandomMovement" = Unit makes random movements in the beginning of the turn,
 ;                 player has no control over its movement
 ; "Flagless"      = Unit national flag is not shown on client, except for
-;                 the owner.
-;                 Note that currently the information is available for
-;                 the client anyway, so this is not a rule like a feature yet.
+;                 the owner. Unit can attack, and it can be attacked,
+;                 regardless of diplomatic pacts between actual unit owners.
 ; "ProvidesRansom" = Enemies can collect ransom from the unit. This only happens
 ;                 if all the units on tile have this flag - any other kind of
 ;                 unit protects them.
diff --git a/data/goldkeep/units.ruleset b/data/goldkeep/units.ruleset
index 0cbe7009fd..fd12ac119e 100644
--- a/data/goldkeep/units.ruleset
+++ b/data/goldkeep/units.ruleset
@@ -401,9 +401,8 @@ flags         = "Unreachable", "DoesntOccupyTile", "HutFrighten"
 ; "RandomMovement" = Unit makes random movements in the beginning of the turn,
 ;                 player has no control over its movement
 ; "Flagless"      = Unit national flag is not shown on client, except for
-;                 the owner.
-;                 Note that currently the information is available for
-;                 the client anyway, so this is not a rule like a feature yet.
+;                 the owner. Unit can attack, and it can be attacked,
+;                 regardless of diplomatic pacts between actual unit owners.
 ; "ProvidesRansom" = Enemies can collect ransom from the unit. This only happens
 ;                 if all the units on tile have this flag - any other kind of
 ;                 unit protects them.
diff --git a/data/granularity/units.ruleset b/data/granularity/units.ruleset
index c6aaa56b21..95aac43a68 100644
--- a/data/granularity/units.ruleset
+++ b/data/granularity/units.ruleset
@@ -333,9 +333,8 @@ flags         = "BuildAnywhere"
 ; "RandomMovement" = Unit makes random movements in the beginning of the turn,
 ;                 player has no control over its movement
 ; "Flagless"      = Unit national flag is not shown on client, except for
-;                 the owner.
-;                 Note that currently the information is available for
-;                 the client anyway, so this is not a rule like a feature yet.
+;                 the owner. Unit can attack, and it can be attacked,
+;                 regardless of diplomatic pacts between actual unit owners.
 ; "ProvidesRansom" = Enemies can collect ransom from the unit. This only happens
 ;                 if all the units on tile have this flag - any other kind of
 ;                 unit protects them.
diff --git a/data/multiplayer/units.ruleset b/data/multiplayer/units.ruleset
index e2f278e8b3..4f572b7c60 100644
--- a/data/multiplayer/units.ruleset
+++ b/data/multiplayer/units.ruleset
@@ -389,9 +389,8 @@ flags         = "Unreachable", "DoesntOccupyTile", "HutFrighten"
 ; "RandomMovement" = Unit makes random movements in the beginning of the turn,
 ;                 player has no control over its movement
 ; "Flagless"      = Unit national flag is not shown on client, except for
-;                 the owner.
-;                 Note that currently the information is available for
-;                 the client anyway, so this is not a rule like a feature yet.
+;                 the owner. Unit can attack, and it can be attacked,
+;                 regardless of diplomatic pacts between actual unit owners.
 ; "ProvidesRansom" = Enemies can collect ransom from the unit. This only happens
 ;                 if all the units on tile have this flag - any other kind of
 ;                 unit protects them.
diff --git a/data/ruledit/comments-3.3.txt b/data/ruledit/comments-3.3.txt
index 5ce2a55bf5..28ee9291da 100644
--- a/data/ruledit/comments-3.3.txt
+++ b/data/ruledit/comments-3.3.txt
@@ -503,9 +503,8 @@ utypes = "\
 ; \"RandomMovement\" = Unit makes random movements in the beginning of the turn,\n\
 ;                 player has no control over its movement\n\
 ; \"Flagless\"      = Unit national flag is not shown on client, except for\n\
-;                 the owner.\n\
-;                 Note that currently the information is available for\n\
-;                 the client anyway, so this is not a rule like a feature yet.\n\
+;                 the owner. Unit can attack, and it can be attacked,\n\
+;                 regardless of diplomatic pacts between actual unit owners.\n\
 ; \"ProvidesRansom\" = Enemies can collect ransom from the unit. This only happens\n\
 ;                 if all the units on tile have this flag - any other kind of\n\
 ;                 unit protects them.\n\
diff --git a/data/sandbox/units.ruleset b/data/sandbox/units.ruleset
index a705e457ee..8dcdeed3c1 100644
--- a/data/sandbox/units.ruleset
+++ b/data/sandbox/units.ruleset
@@ -436,9 +436,8 @@ flags         = "Unreachable", "DoesntOccupyTile", "CanPillage",
 ; "RandomMovement" = Unit makes random movements in the beginning of the turn,
 ;                 player has no control over its movement
 ; "Flagless"      = Unit national flag is not shown on client, except for
-;                 the owner.
-;                 Note that currently the information is available for
-;                 the client anyway, so this is not a rule like a feature yet.
+;                 the owner. Unit can attack, and it can be attacked,
+;                 regardless of diplomatic pacts between actual unit owners.
 ; "ProvidesRansom" = Enemies can collect ransom from the unit. This only happens
 ;                 if all the units on tile have this flag - any other kind of
 ;                 unit protects them.
diff --git a/data/stub/units.ruleset b/data/stub/units.ruleset
index 399b50ee66..589f55734e 100644
--- a/data/stub/units.ruleset
+++ b/data/stub/units.ruleset
@@ -309,9 +309,8 @@ flags         = ""
 ; "RandomMovement" = Unit makes random movements in the beginning of the turn,
 ;                 player has no control over its movement
 ; "Flagless"      = Unit national flag is not shown on client, except for
-;                 the owner.
-;                 Note that currently the information is available for
-;                 the client anyway, so this is not a rule like a feature yet.
+;                 the owner. Unit can attack, and it can be attacked,
+;                 regardless of diplomatic pacts between actual unit owners.
 ; "ProvidesRansom" = Enemies can collect ransom from the unit. This only happens
 ;                 if all the units on tile have this flag - any other kind of
 ;                 unit protects them.
diff --git a/data/webperimental/units.ruleset b/data/webperimental/units.ruleset
index 4ad41abbea..7c3c99a275 100644
--- a/data/webperimental/units.ruleset
+++ b/data/webperimental/units.ruleset
@@ -393,9 +393,8 @@ flags         = "Unreachable", "DoesntOccupyTile", "HutFrighten"
 ; "RandomMovement" = Unit makes random movements in the beginning of the turn,
 ;                 player has no control over its movement
 ; "Flagless"      = Unit national flag is not shown on client, except for
-;                 the owner.
-;                 Note that currently the information is available for
-;                 the client anyway, so this is not a rule like a feature yet.
+;                 the owner. Unit can attack, and it can be attacked,
+;                 regardless of diplomatic pacts between actual unit owners.
 ; "ProvidesRansom" = Enemies can collect ransom from the unit. This only happens
 ;                 if all the units on tile have this flag - any other kind of
 ;                 unit protects them.
-- 
2.43.0